(ns coderloop.reverse-seq
  (:use [clojure.contrib
	 [duck-streams :only [file-str read-lines]]
	 [str-utils :only [re-split]]])
  (:use rlm.shell-inspect)
  (:use [clojure [string :only [trim]]]))

(def c (file-str "/home/r/coderloop-test/reversesequence-c.in"))
(def a (file-str "/home/r/coderloop-test/reversesequence-a.in"))
(def b (file-str "/home/r/coderloop-test/reversesequence-b.in"))

(defn test-trace-map []
  (= [:a :b :c :d :e]
       (trace-map {:a :b :d :e :c :d :b :c})))


(defn read-name-map
  "takes a file of pairs of names and returns a map from the first
   element in those pairs to the second element in the pairs."   
  [#^java.io.File file]
  (let [pairs  (map #(re-split #"\W+" (trim %)) (read-lines file))]
    (zipmap (map first pairs) (map second pairs))))

(defn start-linked-map
  "takes a map-representing-a-list and finds the beginning of that list"
  [m]
  (first (remove (set (vals m)) (keys m))))

(defn trace-map
  "chains through a map-representing-a-list, building a list along the way."
  [m]
  (loop [index (start-linked-map m)
	 chain (vector index)]
    (let [new-index (get m index ::sentinel)]
      (if (= new-index ::sentinel)
	chain
	(recur  new-index (conj chain new-index))))))



(if (command-line?)
  (dorun
   (map println (reverse (trace-map (read-name-map (file-str (first *command-line-args*))))))))
