(ns coderloop.test-mega-tree)

(rlm.ns-rlm/ns-clone rlm.light-base)
(import '[com.coderloop.puzzles Megafasttree Megafasttree$Node])


(defn node [n]
  (Megafasttree$Node. n))


(defn tree [root]
  (doto (Megafasttree.)
    (.addRoot root)))


(defn make-counter []
  (let [a (atom -1)]
    (fn count [] (swap! a inc))))


(defn make-big-ass-tree [depth]
  (let [counter (make-counter)
	root (node (counter))]
    (loop [base [root]
	   level 0]
      (if (= level depth)
	(tree root)
	(do
	  (dorun (map
		  #(doto %
		     (.setLeftChild (node (counter)))
		     (.setRightChild (node (counter))))
		  base))
	  (recur
	   (apply concat (map #(vector (.toLeft %) (.toRight %))
			base))
	   (inc level)))))))
	   

(defn test-shittiness [n]
  (time (do (.bfs (make-big-ass-tree n)) nil)))
